EaBIM一直以来积极响应国家“十二五”推进建筑业信息化的号召,对建筑领域的信息技术开展深入技术交流和探讨!致力于打造“BIM-建筑师-生态技术”三位一体综合资源交流共享平台,希望为BIM与可持续设计理念及技术的普及做出微小的贡献!!!

EaBIM

 找回密码
 注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

搜索
查看: 954|回复: 21
打印 上一主题 下一主题

Parameter of Revit API – 52: Parameter Converter – ProjectParameter to SharedP

[复制链接]

1514

主题

7465

帖子

1万

积分

admin

Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10

积分
12406

社区QQ达人

跳转到指定楼层
楼主
发表于 2014-1-9 11:51:58 | 只看该作者 回帖奖励 |倒序浏览 |阅读模式

We talked about programmatically converting parameters from one to another manually before. Now let’s see how Parameter Converter of RevitAddinWizard can assist us to hit the target with just a few mouse clicks. The Parameter Converter can be found from either Revit Addin Coder sub-menu under the Tools or from Revit Addin Coder toolbar.

When the menu item or the tool button is clicked, the Parameter Converter window will show up:


If the ProjectParameter (to SharedParameter) Converter is selected from the check list box and a class is chosen from the combo box, a ProjectParameter to SharedParameter Converter will be created and added into the class automatically. The entire converter code and necessary namespaces and class declarations have been appended below:

#region Namespaces
using System;
using System.Text;
using System.Linq;
using System.Xml;
using System.Reflection;
using System.ComponentModel;
using System.Collections;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Media.Imaging;
using System.Windows.Forms;
using System.IO;
using Autodesk.Revit.ApplicationServices;
using Autodesk.Revit.Attributes;
using Autodesk.Revit.DB;
using Autodesk.Revit.DB.Events;
using Autodesk.Revit.DB.Architecture;
using Autodesk.Revit.DB.Structure;
using Autodesk.Revit.DB.Mechanical;
using Autodesk.Revit.DB.Electrical;
using Autodesk.Revit.DB.Plumbing;
using Autodesk.Revit.UI;
using Autodesk.Revit.UI.Selection;
using Autodesk.Revit.UI.Events;
using Autodesk.Revit.Collections;
using Autodesk.Revit.Exceptions;
using Autodesk.Revit.Utility;
using RvtApplication = Autodesk.Revit.ApplicationServices.Application;
using RvtDocument = Autodesk.Revit.DB.Document;
#endregion

namespace RevitAddinCS1
{
    class ParameterConverter
    {
        public class RawProjectParameterInfo
        {
            public static string FileName { get; set; }
            public  string Name { get; set; }
            public  BuiltInParameterGroup Group { get; set; }
            public  ParameterType Type { get; set; }
            public  bool ReadOnly { get; set; }
            public  bool BoundToInstance { get; set; }
            public  string[] BoundCategories { get; set; }
            public  bool FromShared { get; set; }
            public  string GUID { get; set; }
            public  string Owner { get; set; }
            public  bool Visible { get; set; }
        }
        public static List<RawProjectParameterInfo> RawGetProjectParametersInfo(Document doc)
        {
            RawProjectParameterInfo.FileName = doc.Title;
            List<RawProjectParameterInfo> paramList = new List<RawProjectParameterInfo>();
            
            BindingMap map = doc.ParameterBindings;
            DefinitionBindingMapIterator it = map.ForwardIterator();
            it.Reset();
            while (it.MoveNext())
            {
                ElementBinding eleBinding = it.Current as ElementBinding;
                InstanceBinding insBinding = eleBinding as InstanceBinding;
                Definition def = it.Key;
                if (def != null )
                {
                    ExternalDefinition extDef = def as ExternalDefinition;
                    bool shared = extDef != null;
                    RawProjectParameterInfo param = new RawProjectParameterInfo
                    {
                    Name = def.Name,
                    Group = def.ParameterGroup,
                    Type = def.ParameterType,
                    ReadOnly = def.IsReadOnly,
                    BoundToInstance = insBinding!=null,
                    BoundCategories = RawConvertSetToList<Category>(eleBinding.Categories).Select(c=>c.Name).ToArray(),
                    FromShared = shared,
                    GUID = shared ? extDef.GUID.ToString() : string.Empty,
                    Owner = shared ? extDef.OwnerGroup.Name : string.Empty,
                    Visible = shared ? extDef.Visible : true,
            
                    };
                    
                    paramList.Add(param);
                }
            }   
            
            return paramList;
        }
        
        public static List<T> RawConvertSetToList<T>(IEnumerable set)
        {
            List<T> list = (from T p in set select p).ToList<T>();
            return list;
        }
        
        
        public static string RawParametersInfoToCSVString<T>(List<T> infoList, ref string title)
        {
            StringBuilder sb = new StringBuilder();
            PropertyInfo[] propInfoArrary = typeof(T).GetProperties();
            foreach (PropertyInfo pi in propInfoArrary)
            {
                title += pi.Name + ",";
            }
            title = title.Remove(title.Length - 1);
        
            foreach (T info in infoList)
            {
                foreach (PropertyInfo pi in propInfoArrary)
                {
                    object obj = info.GetType().InvokeMember(pi.Name, BindingFlags.GetProperty, null, info, null);
                    IList list = obj as IList;
                    if (list != null)
                    {
                        string str = string.Empty;
                        foreach (object e in list)
                        {
                            str += e.ToString() + ";";
                        }
                        str = str.Remove(str.Length - 1);
        
                        sb.Append(str + ",");
                    }
                    else
                    {
                        sb.Append((obj == null ? string.Empty : obj.ToString()) + ",");
                    }
                }
                sb.Remove(sb.Length - 1, 1).Append(Environment.NewLine);
            }
        
            return sb.ToString();
        }
        
        
        public static Definition RawCreateSharedParameter(RvtApplication app, string name, string group, ParameterType type, bool visible)
        {
            DefinitionFile defFile = app.OpenSharedParameterFile();
            if (defFile == null) throw new Exception("No SharedParameter File!");
        
            DefinitionGroup dg = RawConvertSetToList<DefinitionGroup>(defFile.Groups).FirstOrDefault(g => g.Name == group);
            if (dg == null) dg = defFile.Groups.Create(group);
        
            Definition def = RawConvertSetToList<Definition>(dg.Definitions).FirstOrDefault(d => d.Name == name);
            if (def != null) return def; //dg.Definitions.Erase(def);   //ReadOnly Exception!!
            def = dg.Definitions.Create(name, type, visible);
            
            return def;
        }
        
        public static void ConvertProjectParameterInfoToSharedParameter(Document doc, RawProjectParameterInfo info, bool visibilityOverride)
        {
            if (info.Type == ParameterType.Invalid)
            {
                info.Type = ParameterType.Text;
            }
        
            RawCreateSharedParameter(doc.Application, info.Name, "For_" + doc.Title, info.Type, visibilityOverride);
        }
        
        public static void ConvertProjectParameterToSharedParameter(Document doc, string name, bool visibilityOverride)
        {
            List<RawProjectParameterInfo> pList = RawGetProjectParametersInfo(doc);
            List<RawProjectParameterInfo> pListOfInterest = pList.FindAll(p => p.Name == name);
            foreach (RawProjectParameterInfo info in pListOfInterest)
            {
                ConvertProjectParameterInfoToSharedParameter(doc, info, visibilityOverride);
            }
        }
        
        public static void ConvertAllProjectParametersToSharedParameters(Document doc, bool visibilityOverride)
        {
            List<RawProjectParameterInfo> pList = RawGetProjectParametersInfo(doc);
        
            foreach (RawProjectParameterInfo info in pList)
            {
                ConvertProjectParameterInfoToSharedParameter(doc, info, visibilityOverride);
            }
        }
    }
}

We would not create test command to extercise these parameter converter code here. In case needed, please refer to earlier posts for ideas and code examples.

As mentioned, Parameter Converter of RevitAddinCodercan create all these code automatically in a second.

分享到:  QQ好友和群QQ好友和群 QQ空间QQ空间 腾讯微博腾讯微博 腾讯朋友腾讯朋友 微信微信
收藏收藏 转播转播 分享分享 分享淘帖 支持支持 反对反对
工作时间:工作日的9:00-12:00/13:30-18:00,节假日不在线,请勿留言

17

主题

337

帖子

818

积分

BIM项目负责人

Rank: 5Rank: 5Rank: 5Rank: 5Rank: 5

积分
818
推荐
发表于 2014-4-16 12:54:28 来自手机 | 只看该作者
表示还看不懂,顶一个

66

主题

1001

帖子

2354

积分

BIM顾问

Rank: 8Rank: 8Rank: 8Rank: 8Rank: 8Rank: 8Rank: 8Rank: 8

积分
2354

元老勋章特殊贡献勋章

推荐
发表于 2014-6-12 09:42:10 | 只看该作者
路过!!! 不发表意见……
官方主页:www.eabim.net

4

主题

708

帖子

1142

积分

BIM项目负责人

Rank: 5Rank: 5Rank: 5Rank: 5Rank: 5

积分
1142
推荐
发表于 2014-4-8 10:32:57 | 只看该作者
路过!!! 不发表意见……

11

主题

815

帖子

1367

积分

BIM经理

Rank: 6Rank: 6Rank: 6Rank: 6Rank: 6Rank: 6

积分
1367
11F
发表于 2014-4-8 10:27:37 | 只看该作者
顶...... 楼下跟上.....

6

主题

870

帖子

1737

积分

BIM经理

Rank: 6Rank: 6Rank: 6Rank: 6Rank: 6Rank: 6

积分
1737
16F
发表于 2014-5-14 14:03:41 | 只看该作者
(*^__^*) 嘻嘻……
*滑块验证:
您需要登录后才可以回帖 登录 | 注册

本版积分规则

QQ|EaBIM网 ( 苏ICP备2020058923号-1  苏公网安备32011502011255号

GMT+8, 2024-11-27 05:24

Powered by Discuz! X3.2 Licensed

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表